#include "sscan.h"
struct ports *openports;

struct vulns *
scan (u_long ip, u_long localip, struct opts *opts)
{
        struct mountbody *mountl1st;	/* exports on current host. */
        struct pmaplist *portmap;	/* rpc services running on current host. */
        char sparestring[128], *ptr, *ptr2, *ptr3, *spareptr = NULL;
        extern char *stringos;
        extern char *telnetbanner;
        char *currenthostname;
        int index = 0;
        currenthostname = rlookup (ip);
        openports = calloc(1, sizeof(struct ports));
        printf ("--------------------------<[ * report for host %s *", currenthostname);
        /* SETUP PORTS */
        index = 0;

        if (opts->cgi)
        {
                openports->portlist[index] = 80;
                index++;
        }
        if (opts->banner)
        {
                openports->portlist[index] = 23;
                index++;
                openports->portlist[index] = 109;
                index++;
                openports->portlist[index] = 110;
                index++;

        }

        if (opts->rpc)
        {
                openports->portlist[index] = 111;
                index++;
        }
        if (opts->x)
        {
                openports->portlist[index] = 6000;
                index++;
        }
        if (opts->fingers)
        {
                openports->portlist[index] = 79;
                index++;
        }
        if (opts->dns)
        {
                openports->portlist[index] = 53;
                index++;
        }
        if (opts->backdoor)
        {
                openports->portlist[index] = 31337;
                index++;
                /*      openports->portlist[index] = 12345; // Netbus
                      index++;
                      openports->portlist[index] = 12346; // Netbus
                      index++;
                      openports->portlist[index] = 20034; // Netbus 2 pro
                      index++;
                      openports->portlist[index] = 21544; // Girlfriend
                      index++;
                      openports->portlist[index] = 31337; // Back Orfice
                      index++;
                      openports->portlist[index] = 31789; // Hack-a-tack
                      index++;
                      openports->portlist[index] = 54320; // Back Orfice 2000
                      index++;
                      openports->portlist[index] = 65533; // Unix Bindshell
                      index++;
                      openports->portlist[index] = 65534; // Unix Bindshell
                      index++;
                      openports->portlist[index] = 65535; // Unix Bindshell
                      index++; */
        }
        if (opts->llisten)
        {
                openports->portlist[index] = 2766;
                index++;
        }
        openports->portlist[index] = 143;
        index++;
        openports->portlist[index] = 139;
        index++;
        openports->portlist[index] = 25;
        index++;
        openports->portlist[index] = 21;
        index++;
        openports->portlist[index] = 22;
        index++;
        openports->portlist[index] = 1114;
        index++;
        openports->portlist[index] = 1;
        index++;
        openports->portlist[index] = 113;
        index++;

        openports->length = index;
        /* PORT SCAN */
        portscan (ip, openports, opts->verbosity);
        install_alarm_handler (ALARM_PCAP);
        checkos (localip, ip, openports->portlist[0]);
        install_alarm_handler (ALARM_BLOCKING_IO);
        do_modules (localip, ip, 0 /* os */ , "./Osdefs.ms");
        if (opts->only_modules)
                goto modules;
        if (!(!(*stringos)))
                printf ("--<[ *OS*: %s: os detected: %s\n", currenthostname,
                        stringos);

        /* TELNET BANNER */
        if (opts->verbosity && checkport(openports, 23))
        {
                printf ("--<[ *BANNER*: telnet banner:\n %s", telnetbanner);
                close (index);
        }
        /* POP2 BANNER */

        if (checkport (openports, 109))
        {
                spareptr = (char *) getbanner (ip, 109);

                if (spareptr != 0) {
                        if (strstr ((char *) spareptr, "3.35") != (char) NULL)
                                add_vuln ("POP2 remote root buffer overflow");
                        if (strstr ((char *) spareptr, "3.37") != (char) NULL)
                                add_vuln ("POP2 remote root buffer overflow");
                        if (strstr ((char *) spareptr, "3.42") != (char) NULL)
                                add_vuln ("POP2 remote root buffer overflow");
                        if (strstr ((char *) spareptr, "v3.44") != (char) NULL)
                                add_vuln ("POP2 remote root buffer overflow");
                        if (strstr ((char *) spareptr, "v4.46") != (char) NULL)
                                add_vuln ("POP2 remote root buffer overflow");
                        if (strstr ((char *) spareptr, "v4.47") != (char) NULL)
                                add_vuln ("POP2 remote root buffer overflow");

                }

                if (opts->verbosity)
                        printf ("--<[ *BANNER*: POP2 banner follows:\n%s", (char *)
                                spareptr);
        }

        /* POP3 BANNER */
        if (checkport (openports, 110))
        {
                spareptr = (char *) getbanner (ip, 110);
                if (spareptr != 0) {
                        if (strstr ((char *) spareptr, "UCB Pop server (version 1.831") != (char) NULL)
                                add_vuln ("POP3 remote root buffer overflow");
                        if (strstr ((char *) spareptr, "QPOP (version 2.1.4-R3") != (char) NULL)
                                add_vuln ("POP3 remote root buffer overflow");
                        if (strstr ((char *) spareptr, "QPOP (version 2.2") != (char) NULL)
                                add_vuln ("POP3 remote root buffer overflow");
                        if (strstr ((char *) spareptr, "QPOP (version 2.3") != (char) NULL)
                                add_vuln ("POP3 remote root buffer overflow");
                        if (strstr ((char *) spareptr, "QPOP (version 2.41beta1") != (char) NULL)
                                add_vuln ("POP3 remote root buffer overflow");
                        if (strstr ((char *) spareptr, "QPOP (version 2.4b2") != (char) NULL)
                                add_vuln ("POP3 remote root buffer overflow");
                        if (strstr ((char *) spareptr, "3.0b") != (char) NULL)
                                add_vuln ("POP3 remote root buffer overflow");
                        if (strstr ((char *) spareptr, "5.0.0") != (char) NULL)
                                add_vuln ("POP3 remote root buffer overflow");
                       if (strstr ((char *) spareptr, "QPOP (version 2.53") != (char) NULL)
                                add_vuln ("POP3 remote root buffer overflow");
                       if (strstr ((char *) spareptr, "QPOP (version 2.52") != (char) NULL)
                                add_vuln ("POP3 remote root buffer overflow");


                }
                if (opts->verbosity)
                        printf ("--<[ *BANNER*: POP3 banner follows:\n%s", (char *)
                                spareptr);
        }
        /* FTP BANNER */
        if (checkport (openports, 21))
        {
                spareptr = (char *) getbanner (ip, 21);
                if (spareptr != 0) {
                        if (strstr ((char *) spareptr, "ProFTPD 1.2.0pre1") != (char) NULL)
                                add_vuln ("ProFTPD remote root buffer overflow");
                        if (strstr ((char *) spareptr, "ProFTPD 1.2.0pre2") != (char) NULL)
                                add_vuln ("ProFTPD remote root buffer overflow");
                        if (strstr ((char *) spareptr, "ProFTPD 1.2.0pre3") != (char) NULL)
                                add_vuln ("ProFTPD remote root buffer overflow");
                        if (strstr ((char *) spareptr, "ProFTPD 1.2.0pre4") != (char) NULL)
                                add_vuln ("ProFTPD remote root buffer overflow");
                        if (strstr ((char *) spareptr, "ProFTPD 1.2.0pre5") != (char) NULL)
                                add_vuln ("ProFTPD remote root buffer overflow");
                        if (strstr ((char *) spareptr, "ProFTPD 1.2.0pre6") != (char) NULL)
                                add_vuln ("ProFTPD remote root buffer overflow");

                        /* The following line represents all the beta-18 old versions and all the
                           beta18-VR versions */

                        if (strstr ((char *) spareptr, "wu-2.4.2-academ[BETA-1") != (char) NULL)
                                add_vuln ("Wu-FTPD remote root buffer overflow");

                        if (strstr ((char *) spareptr, "wu-2.4.2-VR17") != (char) NULL)
                                add_vuln ("Wu-FTPD remote root buffer overflow");
                        if (strstr ((char *) spareptr, "wu-2.4.2-VR16") != (char) NULL)
                                add_vuln ("Wu-FTPD remote root buffer overflow");
                        if (strstr ((char *) spareptr, "Version wu-2.5.0") != (char) NULL)
                                add_vuln ("Wu-FTPD remote root buffer overflow");

                        if (strstr ((char *) spareptr, "BeroFTPD 1.3.2") != (char) NULL)
                                add_vuln ("BeroFTPD remote root buffer overflow");
                        if (strstr ((char *) spareptr, "BeroFTPD 1.3.3") != (char) NULL)
                                add_vuln ("BeroFTPD remote root buffer overflow");
                        if (strstr ((char *) spareptr, "BeroFTPD 1.3.4") != (char) NULL)
                                add_vuln ("BeroFTPD remote root buffer overflow");

                }
                if (opts->verbosity)
                        printf ("--<[ *BANNER*: FTP banner follows:\n%s", (char *)
                                spareptr);
        
             if(opts->anonlogin) 
             {
              if(checkport (openports, 21) && check_anonlogin(ip))
                        add_vuln("anonymous FTP login is allowed");
             }
            if(checkport (openports, 21) && check_nlogin(ip))
                        add_vuln("System is as good as rooted, l: NULL p: NULL backdoor");


        /* IMAP BANNER */
        if (checkport (openports, 143))
        {
                spareptr = (char *) getbanner (ip, 143);
                if (spareptr !=0) {
                        if (strstr ((char *) spareptr, "IMAP4rev1 Service 9.0") != (char) NULL)
                                add_vuln ("IMAP remote root buffer overflow");
                        if (strstr ((char *) spareptr, "IMAP4rev1 v10.1") != (char) NULL)
                                add_vuln ("IMAP remote root buffer overflow");
                        if (strstr ((char *) spareptr, "IMAP4rev1 v10.20") != (char) NULL)
                                add_vuln ("IMAP remote root buffer overflow");
                        if (strstr ((char *) spareptr, "IMAP4rev1 v10.21") != (char) NULL)
                                add_vuln ("IMAP remote root buffer overflow");
                        if (strstr ((char *) spareptr, "IMAP4rev1 v10.22") != (char) NULL)
                                add_vuln ("IMAP remote root buffer overflow");
                        if (strstr ((char *) spareptr, "IMAP4rev1 v10.233") != (char) NULL)
                                add_vuln ("IMAP remote root buffer overflow");
                        if (strstr ((char *) spareptr, "IMAP4rev1 v10.234") != (char) NULL)
                                add_vuln ("IMAP remote root buffer overflow");
                             }
                        if (opts->verbosity)
                                printf ("--<[ *BANNER*: IMAP banner follows:\n%s", (char
                                                *) spareptr);
                }
        }
        /* sendmail EXPN check */

        if (checkport (openports, 25))
        {

                /* sendmail vuln checks */
                spareptr = (char *) getbanner (ip, 25);
                if (spareptr != NULL) { /* axess: update tihs dude :) */
                        if (strstr ((char *) spareptr, "Sendmail") != (char) NULL && strstr  ((char *) spareptr, "5.55") != (char) NULL)
                                add_vuln ("Sendmail might be overflowable remoteley");
                        if (strstr ((char *) spareptr, "Sendmail") != (char) NULL && strstr  ((char *) spareptr, "5.61") != (char) NULL)
                                add_vuln ("Sendmail might be overflowable remoteley");
                        if (strstr ((char *) spareptr, "Sendmail") != (char) NULL && strstr  ((char *) spareptr, "5.65") != (char) NULL)
                                add_vuln ("Sendmail might be overflowable remoteley");
                        if (strstr ((char *) spareptr, "Sendmail") != (char) NULL && strstr  ((char *) spareptr, "8.6.9") != (char) NULL)
                                add_vuln ("Sendmail might be overflowable remoteley");
                        if (strstr ((char *) spareptr, "Sendmail") != (char) NULL && strstr  ((char *) spareptr, "8.8.0") != (char) NULL)
                                add_vuln ("Sendmail might be overflowable remoteley");
                        if (strstr ((char *) spareptr, "Sendmail") != (char) NULL && strstr ((char *) spareptr, "8.8.4") != (char) NULL)
                                add_vuln ("Sendmail might be overflowable remoteley");
                        if (strstr ((char *) spareptr, "Sendmail") != (char) NULL && strstr  ((char *) spareptr, "8.8.8") != (char) NULL)
                                add_vuln ("Sendmail might be overflowable remoteley");
                        if (strstr ((char *) spareptr, "Sendmail") != (char) NULL && strstr  ((char *) spareptr, "8.9.2") != (char) NULL)
                                add_vuln ("Sendmail might be overflowable remoteley");
                        if (strstr ((char *) spareptr, "Sendmail") != (char) NULL && strstr  ((char *) spareptr, "4.1") != (char) NULL)
                                add_vuln ("Sendmail might be overflowable remoteley");
                        if (strstr ((char *) spareptr, "Sendmail") != (char) NULL && strstr  ((char *) spareptr, "8.65") != (char) NULL)
                                add_vuln ("Sendmail might be overflowable remoteley");
                        if (strstr ((char *) spareptr, "Sendmail") != (char) NULL && strstr  ((char *) spareptr, "8.6.7") != (char) NULL)
                                add_vuln ("Sendmail might be overflowable remoteley");
                        if (strstr ((char *) spareptr, "Sendmail") != (char) NULL && strstr  ((char *) spareptr, "8.6.10") != (char) NULL)
                                add_vuln ("Sendmail might be overflowable remoteley");
                        if (strstr ((char *) spareptr, "Sendmail") != (char) NULL && strstr  ((char *) spareptr, "4.1") != (char) NULL)
                                add_vuln ("Sendmail might be overflowable remoteley");
                        if (strstr ((char *) spareptr, "Sendmail") != (char) NULL && strstr  ((char *) spareptr, "8.65") != (char) NULL)
                                add_vuln ("Sendmail might be overflowable remoteley");

                        if (opts->verbosity)
                                printf ("--<[ *BANNER*: Mail banner follows:\n%s", (char
                                                *) spareptr);
                }
                if (sendmail_expn_check (ip, "root") && strstr ((char *) spareptr, "Sendmail") )
                        add_vuln ("sendmail will 'expn' accounts for us");
        }

        /* LLISTEN CHECK */
        if (checkport (openports, 2766) && os ("solaris"))
                add_vuln ("solaris x86 listen/nlps_serv remote root overflow");
        if (checkport (openports, 1114) && os ("linux"))
                add_vuln ("linux running mysql 2.0, remote stack overflow");
        if (checkport(openports, 53) && (os("linux") || os("bsd")))
                if(checknamed(myntoa(ip))) add_vuln("linux bind/iquery buffer overflow");
        /* CGI CHECKS */

        if (checkport (openports, 80) && !os ("windows"))

        {

                if(!os("windows")) {

                        spareptr = (char *) gethttphead (ip);

                        if (opts->verbosity)
                                printf ("--<[ *HTTP Version:-->[Head]\n%s", (char *)
                                        spareptr);


                }

                if (!os ("windows")) {
                        /* Vulnerable HTTP Version checks */
                        if (strstr ((char *) spareptr, "Apache") !=  (char) NULL && strstr((char*) spareptr,"1.2.") != (char) NULL)
                                add_vuln ("Apache/1.2.x is running... [load average hole]");
                        if (strstr ((char *) spareptr, "Apache") !=  (char) NULL && strstr((char*) spareptr,"1.1.1") != (char) NULL && strstr((char*) spareptr,"Set Cookie:") != (char) NULL)
                                add_vuln ("Apache/1.1.1 is running... [cookie problem]");
                        if (strstr ((char *) spareptr, "PHP/FI Version 2.0b10") !=  (char) NULL)
                                add_vuln ("PHP/FI Version 2.0b10 is running... [feel free to panic]");
                        if (strstr ((char *) spareptr, "NCSA/1.5") !=  (char) NULL)
                                add_vuln("NCSA/1.5 is running... [remote access]");

                        /* end of httpd scan */
                        if (check_cgi (ip, "/cgi-bin/phf"))
                                add_vuln ("/cgi-bin/phf here.. shell escape?");
                        if (check_cgi (ip, "/cgi-bin/Count.cgi"))
                                add_vuln ("/cgi-bin/Count.cgi remote overflow?");
                        if (check_cgi (ip, "/cgi-bin/test-cgi"))
                                add_vuln ("/cgi-bin/test-cgi here.");
                        if (check_cgi (ip, "/cgi-bin/php.cgi"))
                                add_vuln ("/cgi-bin/php.cgi here.");
                        if (check_cgi (ip, "/cgi-bin/handler"))
                                add_vuln ("/cgi-bin/handler (shell escape..?)");
                        if (check_cgi (ip, "/cgi-bin/webgais"))
                                add_vuln ("/cgi-bin/webgais is here.");
                        if (check_cgi (ip, "/cgi-bin/websendmail"))
                                add_vuln ("/cgi-bin/websendmail is here.");
                        if (check_cgi (ip, "/cgi-bin/webdist.cgi"))
                                add_vuln ("/cgi-bin/webdist.cgi is here.");
                        if (check_cgi (ip, "/cgi-bin/faxsurvey"))
                                add_vuln ("/cgi-bin/faxsurvery is here.");
                        if (check_cgi (ip, "/cgi-bin/htmlscript"))
                                add_vuln ("/cgi-bin/htmlscript is here.");
                        if (check_cgi (ip, "/cgi-bin/pfdisplay.cgi"))
                                add_vuln ("/cgi-bin/pfdisplay.cgi is here.");

                        /* update for CGI starts here, will try to make this cleaner later on */
                        if (check_cgi (ip, "/cgi-bin/unlg1.1"))
                                add_vuln ("/cgi-bin/unlg1.1 is here, unlg backd00r");
                        if (check_cgi (ip, "/cgi-bin/rwwwshell.pl"))
                                add_vuln ("/cgi-bin/rwwwshell.pl is here, THC backd00r");

                        if (check_cgi (ip, "/cgi-bin/finger"))
                                add_vuln ("/cgi-bin/finger is here");
                }

        }



        if(checkport (openports, 80) && os("windows"))
        {
                spareptr = (char *) gethttphead (ip);

                if (opts->verbosity)
                        printf ("--<[ *HTTP Version:-->[Head]\n\n%s", (char *)
                                spareptr);
                /* Vulnerable HTTP Version checks */
                if (strstr ((char *) spareptr, "Microsoft-IIS/4.0") != (char) NULL)
                        add_vuln ("Microsoft-IIS/4.0 [DoS/Exploit Remote overflow(???)]");
                if (strstr ((char *) spareptr, "Microsoft-IIS/5.0") != (char) NULL)
                        add_vuln ("Microsoft-IIS/5.0 [DoS/Exploit Remote overflow(???)]");


                if (strstr ((char *) spareptr, "Novell-HTTP-Server/2.51R1") != (char) NULL)
                        add_vuln ("Novell-HTTP-Server/2.51R1 [DoS/Exploit(???)]");
                if (strstr ((char *) spareptr, "Novell-HTTP-Server/3.1R1") != (char) NULL)
                        add_vuln ("Novell-HTTP-Server/3.1R1 [DoS/Exploit(???)]");


                /* End Vulnerable HTTP Version Checks */
                if (check_cgi (ip, "/cgi-bin/perl.exe"))
                        add_vuln ("/cgi-bin/perl.exe is here.");
                if (check_cgi (ip, "/cgi-bin/wwwboard.pl"))
                        add_vuln ("/cgi-bin/wwwboard.pl is here.");
                if (check_cgi (ip, "/cgi-bin/counter.exe"))
                        add_vuln ("/cgi-bin/counter.exe is here");

                if (check_cgi (ip, "/cfdocs/zero.cfm"))
                        add_vuln ("/cfdocs/zero.cfm is here");
                if (check_cgi (ip, "/cfdocs/root.cfm"))
                        add_vuln ("/cfdocs/root.cfm is here");
                if (check_cgi (ip, "/cfdocs/expressions.cfm"))
                        add_vuln ("/cfdocs/expressions.cfm is here");
                if (check_cgi (ip, "/cfdocs/TOXIC.CFM"))
                        add_vuln ("/cfdocs/TOXIC.CFM is here");
                if (check_cgi (ip, "/cfdocs/MOLE.CFM"))
                        add_vuln ("/cfdocs/MOLE.CFM is here");
                if (check_cgi (ip, "/cfdocs/expeval/exprcalc.cfm"))
                        add_vuln ("/cfdocs/expeval/exprcalc.cfm is here");
                if (check_cgi (ip, "/cfdocs/expeval/sendmail.cfm"))
                        add_vuln ("/cfdocs/expeval/sendmail.cfm is here");
                if (check_cgi (ip, "/cfdocs/expeval/eval.cfm"))
                        add_vuln ("/cfdocs/expeval/eval.cfm is here");
                if (check_cgi (ip, "/cfdocs/expeval/openfile.cfm"))
                        add_vuln ("/cfdocs/expeval/openfile.cfm is here");
                if (check_cgi (ip, "/cfdocs/exampleapp/publish/admin/addcontent.cfm"))
                        add_vuln ("/cfdocs/exampleapp/publish/admin/addcontent.cfm is here");
                if (check_cgi (ip, "/cfdocs/expeval/displayopenedfile.cfm"))
                        add_vuln ("/cfdocs/expeval/displayopenedfile.cfm is here");
                if (check_cgi (ip, "/cfdocs/exampleapp/email/getfile.cfm?filename=c:\boot.ini"))
                        add_vuln ("/cfdocs/exampleapp/email/getfile.cfm?filename=c:\boot.ini is here");
                if (check_cgi (ip, "/cfdocs/exampleapp/publish/admin/application.cfm"))
                        add_vuln ("/cfdocs/exampleapp/publish/admin/application.cfm is here");
                if (check_cgi (ip, "/cfdocs/exampleapp/email/application.cfm"))
                        add_vuln ("/cfdocs/exampleapp/email/application.cfm is here");
                if (check_cgi (ip, "/cfdocs/exampleapp/docs/sourcewindow.cfm"))
                        add_vuln ("/cfdocs/exampleapp/docs/sourcewindow.cfm is here");
                if (check_cgi (ip, "/cfdocs/examples/parks/detail.cfm"))
                        add_vuln ("/cfdocs/examples/parks/detail.cfm is here");
                if (check_cgi (ip, "/cgi-bin/windmail.exe"))
                        add_vuln ("/cgi-bin/windmail.exe is here");
                if (check_cgi (ip, "/cfdocs/examples/cvbeans/beaninfo.cfm"))
                        add_vuln ("/cfdocs/examples/cvbeans/beaninfo.cfm is here");
                if (check_cgi (ip, "/cfdocs/cfmlsyntaxcheck.cfm"))
                        add_vuln ("/cfdocs/cfmlsyntaxcheck.cfm is here");
                if (check_cgi (ip, "/cfdocs/snippets/viewexample.cfm"))
                        add_vuln ("/cfdocs/snippets/viewexample.cfm is here");
                if (check_cgi (ip, "/cfdocs/snippets/gettempdirectory.cfm"))
                        add_vuln ("/cfdocs/snippets/gettempdirectory.cfm is here");
                if (check_cgi (ip, "/cfdocs/snippets/fileexists.cfm"))
                        add_vuln ("/cfdocs/snippets/fileexists.cfm is here");
                if (check_cgi (ip, "/cfdocs/snippets/evaluate.cfm"))
                        add_vuln ("/cfdocs/snippets/evaluate.cfm is here");
                if (check_cgi (ip, "/cfappman/index.cfm"))
                        add_vuln ("/cfappman/index.cfm is here");
                if (check_cgi (ip, "/cfusion/cfapps/forums/forums_.mdb"))
                        add_vuln ("/cfusion/cfapps/forums/forums_.mdb is here");
                if (check_cgi (ip, "/cfusion/cfapps/security/realm_.mdb"))
                        add_vuln ("/cfusion/cfapps/security/realm_.mdb is here");
                if (check_cgi (ip, "/cfusion/cfapps/security/realm_.mdb"))
                        add_vuln ("/cfusion/cfapps/security/realm_.mdb is here");
                if (check_cgi (ip, "/cfusion/cfapps/forums/data/forums.mdb"))
                        add_vuln ("/cfusion/cfapps/forums/data/forums.mdb is here");
                if (check_cgi (ip, "/cfusion/cfapps/security/data/realm.mdb"))
                        add_vuln ("/cfusion/cfapps/security/data/realm.mdb is here");
                if (check_cgi (ip, "/cfusion/database/cfexamples.mdb"))
                        add_vuln ("/cfusion/database/cfexamples.mdb is here");
                if (check_cgi (ip, "/cfusion/database/cfsnippets.mdb"))
                        add_vuln ("/cfusion/database/cfsnippets.mdb is here");
                if (check_cgi (ip, "/cfusion/database/smpolicy.mdb"))
                        add_vuln ("/cfusion/database/smpolicy.mdb is here");
                if (check_cgi (ip, "/cfusion/database/cypress.mdb"))
                        add_vuln ("/cfusion/database/cypress.mdb is here");
                if (check_cgi (ip, "/DataBase/"))
                        add_vuln ("/DataBase/ is here");
                if (check_cgi (ip, "/database.nsf/e1466a8590/6048076233?OpenDocument"))
                        add_vuln ("/database.nsf/e1466a8590/6048076233?OpenDocument is here");
                if (check_cgi (ip, "/database.nsf/e146fa8590/6148076233?EditDocument"))
                        add_vuln ("/database.nsf/e146fa8590/6148076233?EditDocument is here");
                if (check_cgi (ip, "/database.nsf/e146fa8590/6148076233?DeleteDocument"))
                        add_vuln ("/database.nsf/e146fa8590/6148076233?DeleteDocument is here");
                if (check_cgi (ip, "/domcfg.nsf/URLRedirect/?OpenForm."))
                        add_vuln ("/domcfg.nsf/URLRedirect/?OpenForm. is here");
                if (check_cgi (ip, "/domcfg.nsf/"))
                        add_vuln ("/domcfg.nsf/ is here");
                if (check_cgi (ip, "/domlog.nsf/"))
                        add_vuln ("/domlog.nsf/ is here");
                if (check_cgi (ip, "/log.nsf/"))
                        add_vuln ("/log.nsf/ is here");
                if (check_cgi (ip, "/catalog.nsf/"))
                        add_vuln ("/catalog.nsf/ is here");
                if (check_cgi (ip, "/names.nsf/"))
                        add_vuln ("/names.nsf/ is here");
                if (check_cgi (ip, "/database.nsf/"))
                        add_vuln ("/database.nsf/ is here");
                if (check_cgi (ip, "/today.nsf/"))
                        add_vuln ("/today.nsf/ is here");
                if (check_cgi (ip, "/cgi-bin/cgi-lib.pl"))
                        add_vuln ("/cgi-bin/cgi-lib.pl is here");
                if (check_cgi (ip, "/cgi-bin/imagemap.c"))
                        add_vuln ("/cgi-bin/imagemap.c is here");
                if (check_cgi (ip, "/cgi-bin/imagemap.exe"))
                        add_vuln ("/cgi-bin/imagemap.exe is here");
                if (check_cgi (ip, "/cgi-bin/minimal.exe"))
                        add_vuln ("/cgi-bin/minimal.exe is here");
                if (check_cgi (ip, "/cgi-bin/redir.exe"))
                        add_vuln ("/cgi-bin/redir.exe is here");
                if (check_cgi (ip, "/cgi-bin/stats.prg"))
                        add_vuln ("/cgi-bin/stats.prg is here");
                if (check_cgi (ip, "/cgi-bin/statsconfig"))
                        add_vuln ("/cgi-bin/statsconfig is here");
                if (check_cgi (ip, "/cgi-bin/visadmin.exe"))
                        add_vuln ("/cgi-bin/visadmin.exe is here");
                if (check_cgi (ip, "/cgi-bin/visitor.exe"))
                        add_vuln ("/cgi-bin/visitor.exe is here");
                if (check_cgi (ip, "/cgi-bin/htmldocs"))
                        add_vuln ("/cgi-bin/htmldocs is here");
                if (check_cgi (ip, "/cgi-bin/logs"))
                        add_vuln ("/cgi-bin/logs is here");
                if (check_cgi (ip, "/scripts/cpshost.dll"))
                        add_vuln ("/scripts/cpshost.dll is here");
                if (check_cgi (ip, "/scripts/CGImail.exe"))
                        add_vuln ("/scripts/CGImail.exe is here");
                if (check_cgi (ip, "/scripts/perl? "))
                        add_vuln ("/scripts/perl? is here");
                if (check_cgi (ip, "..../Windows/Admin.pwl"))
                        add_vuln ("..../Windows/Admin.pwl is here");
                if (check_cgi (ip, "/AdvWorks/equipment/catalog_type.asp"))
                        add_vuln ("/AdvWorks/equipment/catalog_type.asp is here");
                if (check_cgi (ip, "/scripts/c32web.exe"))
                        add_vuln ("/scripts/c32web.exe is here");



        }
        /* DNS CHECK */
        if (checkport (openports, 53) && os ("linux"))
                add_vuln ("linux bind/iquery remote buffer overflow");
        /* BACKDOOR CHECK */
        if (checkport (openports, 31337))
                add_vuln ("port 31337(tcp) open.. backdoor?");

        /* RPC CHECK */
        if (checkport (openports, 111) && !os ("windows"))
        {
                portmap = (struct pmaplist *) rpcinfo (ip);
                if (opts->verbosity)
                        printrpc (portmap, ip);
                mountl1st = (struct mountbody *) nfsinfo (ip);
                if (opts->verbosity)
                        printf ("--<[ * exports ....? * ]>--\n");
                if (printexports (ip, mountl1st))
                        add_vuln ("world readable/writeable nfs exports");
                if (os ("linux"))
                        if (checkrpc (portmap, "mountd"))
                                add_vuln ("linux mountd remote buffer overflow");
                if (os ("solaris")) {
                        if (checkrpc (portmap, "rstatd"))
                                add_vuln ("solaris running statd (automountd remote?)");
                        if (checkrpc (portmap, "rpc.nisd") || checkrpc (portmap, "ypserv"))
                                add_vuln ("solaris running NIS services.. remote overflow?");
                        if (checkrpc (portmap, "nlockmgr"))
                                add_vuln ("solaris running nlockmgr.. remote overflow?");
                }
        }
        /* X11 CHECK */
        if (checkport (openports, 6000) && !os ("windows"))
        {
                bzero (sparestring, sizeof (sparestring));
                strcpy (sparestring, (char *) myntoa (ip));
                strcat (sparestring, ":0");
                if (XOpenDisplay ((char *) sparestring) != NULL)
                        add_vuln ("the X display can be dumped/sniffed");
        }
        if (strstr (telnetbanner, "Gate>") != NULL)
                add_vuln ("Runs WinGate");
        /* FINGER CHECKS */
        if (checkport (openports, 79) && (!os("windows")))
        {
                if (opts->verbosity) {
                        printf ("\n--<[ * fingering accounts... * ]>--\n");
                        printf ("%s\n", finger (ip, "\r\n"));
                }
                ptr = opts->fingers;
                ptr2 = NULL;
                while (1) {
                        ptr2 = strtok (ptr, ",");
                        if (ptr2 == NULL)
                                break;
                        snprintf (sparestring, sizeof (sparestring), "%s\r\n", ptr2);
                        ptr3 = finger (ip, sparestring);
                        if (!ptr3)
                                break;
                        if ((strstr (ptr3, "no such user") != NULL))
                                continue;
                        else if (strstr (ptr3, "Never logged") != NULL)
                                printf ("-<[ *FINGER*: %s: %s: is a user who has never logged in.\n", currenthostname, ptr2);
                        else if (strstr (ptr3, "Login") != NULL)
                                printf ("-<[ *FINGER*: %s: %s: account exists.\n",
                                        currenthostname, ptr2);
                        else if (opts->verbosity)
                                printf ("-<[ *FINGER*: %s: uninterpreted finger output: %s\n",
                                        currenthostname, ptr3);
                        ptr += (strlen (ptr2) + 1);
                }
        }
        printf("--<[ *VULN REPORT SUMMARY: %s\n",currenthostname);
        if (opts->do_modules)
        {
modules:
                do_modules (localip, ip, 0, opts->module);
                if(opts->doextrascript)
                        do_modules (localip, ip, 0, opts->extrascript);
        }
        printvulns (currenthostname);
        printf ("---------------------------<[ * scan of %s completed *\n\n",
                currenthostname);
        write (1, "\n\n", 2);
 return NULL;
}
